Index: /branches/HTM-15.2-dev/source/Lib/TLibCommon/TComInterpolationFilter.h
===================================================================
--- /branches/HTM-15.2-dev/source/Lib/TLibCommon/TComInterpolationFilter.h	(revision 1363)
+++ /branches/HTM-15.2-dev/source/Lib/TLibCommon/TComInterpolationFilter.h	(revision 1364)
@@ -88,9 +88,8 @@
 #endif
 
-  Void filterVer(const ComponentID compID, Pel *src, Int srcStride, Pel *dst, Int dstStride, Int width, Int height, Int frac, Bool isFirst, Bool isLast, const ChromaFormat fmt, const Int bitDepth 
 #if NH_3D_ARP
-  Void filterVer(const ComponentID compID, Pel *src, Int srcStride, Pel *dst, Int dstStride, Int width, Int height, Int frac, Bool isFirst, Bool isLast, const ChromaFormat fmt, const Int bitDepth , Bool filterType = false );
+  Void filterVer(const ComponentID compID, Pel *src, Int srcStride, Pel *dst, Int dstStride, Int width, Int height, Int frac,               Bool isFirst, Bool isLast, const ChromaFormat fmt, const Int bitDepth , Bool filterType = false );
 #else
-  Void filterVer(const ComponentID compID, Pel *src, Int srcStride, Pel *dst, Int dstStride, Int width, Int height, Int frac, Bool isFirst, Bool isLast, const ChromaFormat fmt, const Int bitDepth );
+  Void filterVer(const ComponentID compID, Pel *src, Int srcStride, Pel *dst, Int dstStride, Int width, Int height, Int frac,               Bool isFirst, Bool isLast, const ChromaFormat fmt, const Int bitDepth );
 #endif
 };
Index: /branches/HTM-15.2-dev/source/Lib/TLibCommon/TComPrediction.cpp
===================================================================
--- /branches/HTM-15.2-dev/source/Lib/TLibCommon/TComPrediction.cpp	(revision 1363)
+++ /branches/HTM-15.2-dev/source/Lib/TLibCommon/TComPrediction.cpp	(revision 1364)
@@ -1912,18 +1912,23 @@
     const Int vFilterSize = isLuma(compID) ? NTAPS_LUMA : NTAPS_CHROMA;
 
-    m_if.filterHor(compID, ref - ((vFilterSize>>1) -1)*refStride, refStride, tmp, tmpStride, cxWidth, cxHeight+vFilterSize-1, xFrac, false,      chFmt, bitDepth
 #if NH_3D_ARP 
-    , filterType
+    m_if.filterHor(compID, ref - ((vFilterSize>>1) -1)*refStride, refStride, tmp, tmpStride, cxWidth, cxHeight+vFilterSize-1, xFrac, false,      chFmt, bitDepth, filterType );
+#else
+    m_if.filterHor(compID, ref - ((vFilterSize>>1) -1)*refStride, refStride, tmp, tmpStride, cxWidth, cxHeight+vFilterSize-1, xFrac, false,      chFmt, bitDepth );
 #endif 
-);
+
+#if NH_3D
+    m_if.filterVer(compID, tmp + ((vFilterSize>>1) -1)*tmpStride, tmpStride, dst, dstStride, cxWidth, cxHeight,               yFrac, false, !bi
 #if NH_3D_IC
-    m_if.filterVer(compID, tmp + ((vFilterSize>>1) -1)*tmpStride, tmpStride, dst, dstStride, cxWidth, cxHeight,               yFrac, false, !bi || bICFlag, chFmt, bitDepth
-#else
-    m_if.filterVer(compID, tmp + ((vFilterSize>>1) -1)*tmpStride, tmpStride, dst, dstStride, cxWidth, cxHeight,               yFrac, false, !bi, chFmt, bitDepth
-#endif
+    || bICFlag
+#endif
+    , chFmt, bitDepth
 #if NH_3D_ARP
     , filterType
 #endif 
 );
+#else
+    m_if.filterVer(compID, tmp + ((vFilterSize>>1) -1)*tmpStride, tmpStride, dst, dstStride, cxWidth, cxHeight,               yFrac, false, !bi, chFmt, bitDepth );
+#endif
   }
 
Index: /branches/HTM-15.2-dev/source/Lib/TLibCommon/TComPrediction.h
===================================================================
--- /branches/HTM-15.2-dev/source/Lib/TLibCommon/TComPrediction.h	(revision 1363)
+++ /branches/HTM-15.2-dev/source/Lib/TLibCommon/TComPrediction.h	(revision 1364)
@@ -115,4 +115,5 @@
 #endif
 
+#if NH_3D
   Void xPredInterBlk(const ComponentID compID, TComDataCU *cu, TComPicYuv *refPic, UInt partAddr, TComMv *mv, Int width, Int height, TComYuv *dstPic, Bool bi, const Int bitDepth
 #if NH_3D_ARP
@@ -123,5 +124,7 @@
 #endif
  );
-
+#else
+  Void xPredInterBlk(const ComponentID compID, TComDataCU *cu, TComPicYuv *refPic, UInt partAddr, TComMv *mv, Int width, Int height, TComYuv *dstPic, Bool bi, const Int bitDepth );
+#endif
 #if NH_3D_VSP
   Void xPredInterUniSubPU        ( TComDataCU *cu, UInt uiPartAddr, Int iWidth, Int iHeight, RefPicList eRefPicList, TComYuv*& rpcYuvPred, Bool bi, Int widthSubPU=4, Int heightSubPU=4 );
Index: /branches/HTM-15.2-dev/source/Lib/TLibCommon/TComRdCost.cpp
===================================================================
--- /branches/HTM-15.2-dev/source/Lib/TLibCommon/TComRdCost.cpp	(revision 1363)
+++ /branches/HTM-15.2-dev/source/Lib/TLibCommon/TComRdCost.cpp	(revision 1364)
@@ -120,73 +120,4 @@
     }
   }
-}
-
-#if NH_3D_VSO
-Double TComRdCost::calcRdCost64( UInt64 uiBits, Dist64 uiDistortion, Bool bFlag, DFunc eDFunc )
-#else
-Double TComRdCost::calcRdCost64( UInt64 uiBits, UInt64 uiDistortion, Bool bFlag, DFunc eDFunc )
-#endif
-{
-  Double dRdCost = 0.0;
-  Double dLambda = 0.0;
-
-  switch ( eDFunc )
-  {
-    case DF_SSE:
-      assert(0);
-      break;
-    case DF_SAD:
-      dLambda = m_dLambdaMotionSAD[0]; // 0 is valid, because for lossless blocks, the cost equation is modified to compensate.
-      break;
-    case DF_DEFAULT:
-      dLambda =         m_dLambda;
-      break;
-    case DF_SSE_FRAME:
-      dLambda =         m_dFrameLambda;
-      break;
-    default:
-      assert (0);
-      break;
-  }
-
-  if (bFlag) //NOTE: this "bFlag" is never true
-  {
-    // Intra8x8, Intra4x4 Block only...
-    if (m_costMode != COST_STANDARD_LOSSY)
-    {
-      dRdCost = (Double(uiDistortion) / dLambda) + Double(uiBits); // all lossless costs would have uiDistortion=0, and therefore this cost function can be used.
-    }
-    else
-    {
-      dRdCost = (((Double)(Int64)uiDistortion) + ((Double)(Int64)uiBits * dLambda));
-    }
-  }
-  else
-  {
-    if (eDFunc == DF_SAD)
-    {
-      if (m_costMode != COST_STANDARD_LOSSY)
-      {
-        dRdCost = ((Double(uiDistortion) * 65536) / dLambda) + Double(uiBits); // all lossless costs would have uiDistortion=0, and therefore this cost function can be used.
-      }
-      else
-      {
-        dRdCost = floor(Double(uiDistortion) + (floor((Double(uiBits) * dLambda) + 0.5) / 65536.0));
-      }
-    }
-    else
-    {
-      if (m_costMode != COST_STANDARD_LOSSY)
-      {
-        dRdCost = (Double(uiDistortion) / dLambda) + Double(uiBits); // all lossless costs would have uiDistortion=0, and therefore this cost function can be used.
-      }
-      else
-      {
-        dRdCost = floor(Double(uiDistortion) + (Double(uiBits) * dLambda) + 0.5);
-      }
-    }
-  }
-
-  return dRdCost;
 }
 
Index: /branches/HTM-15.2-dev/source/Lib/TLibCommon/TComSlice.h
===================================================================
--- /branches/HTM-15.2-dev/source/Lib/TLibCommon/TComSlice.h	(revision 1363)
+++ /branches/HTM-15.2-dev/source/Lib/TLibCommon/TComSlice.h	(revision 1364)
@@ -2246,6 +2246,4 @@
   virtual ~TComRefPicListModification();
 
-  Void    create();
-  Void    destroy();
 
   Bool    getRefPicListModificationFlagL0() const        { return m_refPicListModificationFlagL0;                                  }
@@ -2272,5 +2270,4 @@
   Void    setListEntryL1( Int i, Int  val )                      { m_RefPicSetIdxL1[i] = val;                                          } 
 #endif
-
 };
 
@@ -2528,5 +2525,4 @@
   const TComPPSRExt&     getPpsRangeExtension() const                                     { return m_ppsRangeExtension;                   }
   TComPPSRExt&           getPpsRangeExtension()                                           { return m_ppsRangeExtension;                   }
-
 #if NH_MV
   Void    setLayerId( Int  val )                                                     { m_layerId = val;                                           }
Index: /branches/HTM-15.2-dev/source/Lib/TLibCommon/TypeDef.h
===================================================================
--- /branches/HTM-15.2-dev/source/Lib/TLibCommon/TypeDef.h	(revision 1363)
+++ /branches/HTM-15.2-dev/source/Lib/TLibCommon/TypeDef.h	(revision 1364)
@@ -64,4 +64,5 @@
 /////////////////////////////////////////////////////////////////////////////////////////
 #if NH_MV
+#define H_MV_HLS_PTL_LIMITS                       0
 #define NH_MV_SEI_TBD                             0
 #define NH_MV_SEI                                 1