Index: /branches/HTM-15.2-dev/source/Lib/TLibEncoder/SEIwrite.cpp
===================================================================
--- /branches/HTM-15.2-dev/source/Lib/TLibEncoder/SEIwrite.cpp	(revision 1366)
+++ /branches/HTM-15.2-dev/source/Lib/TLibEncoder/SEIwrite.cpp	(revision 1367)
@@ -902,5 +902,5 @@
 }
 
-
+#if NH_MV
 #if NH_MV_LAYERS_NOT_PRESENT_SEI
 Void SEIWriter::xWriteSEILayersNotPresent(const SEILayersNotPresent& sei)
@@ -1457,5 +1457,5 @@
 };
 #endif
-
+#endif
 
 //! \}
Index: /branches/HTM-15.2-dev/source/Lib/TLibEncoder/SEIwrite.h
===================================================================
--- /branches/HTM-15.2-dev/source/Lib/TLibEncoder/SEIwrite.h	(revision 1366)
+++ /branches/HTM-15.2-dev/source/Lib/TLibEncoder/SEIwrite.h	(revision 1367)
@@ -81,4 +81,5 @@
   Void xWriteSEIMasteringDisplayColourVolume( const SEIMasteringDisplayColourVolume& sei);
 
+#if NH_MV
 #if NH_MV_SEI
 #if NH_MV_LAYERS_NOT_PRESENT_SEI
@@ -108,8 +109,10 @@
   Void xWriteSEIAlternativeDepthInfo          ( const SEIAlternativeDepthInfo& sei);
 #endif
+#endif
+#endif
+
   Void xWriteSEIpayloadData(TComBitIf& bs, const SEI& sei, const TComSPS *sps);
   Void xWriteByteAlign();
 };
-#endif
 
 //! \}
Index: /branches/HTM-15.2-dev/source/Lib/TLibEncoder/TEncEntropy.h
===================================================================
--- /branches/HTM-15.2-dev/source/Lib/TLibEncoder/TEncEntropy.h	(revision 1366)
+++ /branches/HTM-15.2-dev/source/Lib/TLibEncoder/TEncEntropy.h	(revision 1367)
@@ -139,9 +139,11 @@
   Void    setBitstream              ( TComBitIf* p )          { m_pcEntropyCoderIf->setBitstream(p);  }
   Void    resetBits                 ()                        { m_pcEntropyCoderIf->resetBits();      }
+#if NH_MV
   UInt    getNumberOfWrittenBits    ()                        {
-#if NH_MV
       D_PRINT_INDENT(g_encNumberOfWrittenBits,  "NumBits: " +  n2s( m_pcEntropyCoderIf->getNumberOfWrittenBits() ))
-#endif
  return m_pcEntropyCoderIf->getNumberOfWrittenBits(); }
+#else
+  UInt    getNumberOfWrittenBits    ()                        { return m_pcEntropyCoderIf->getNumberOfWrittenBits(); }
+#endif
   Void    resetEntropy              (const TComSlice *pSlice) { m_pcEntropyCoderIf->resetEntropy(pSlice);  }
   SliceType determineCabacInitIdx   (const TComSlice *pSlice) { return m_pcEntropyCoderIf->determineCabacInitIdx(pSlice); }
Index: /branches/HTM-15.2-dev/source/Lib/TLibEncoder/TEncGOP.cpp
===================================================================
--- /branches/HTM-15.2-dev/source/Lib/TLibEncoder/TEncGOP.cpp	(revision 1366)
+++ /branches/HTM-15.2-dev/source/Lib/TLibEncoder/TEncGOP.cpp	(revision 1367)
@@ -605,7 +605,4 @@
 Void TEncGOP::xCreatePictureTimingSEI  (Int IRAPGOPid, SEIMessages& seiMessages, SEIMessages& nestedSeiMessages, SEIMessages& duInfoSeiMessages, TComSlice *slice, Bool isField, std::deque<DUData> &duData)
 {
-#if !NH_MV
-  SEIPictureTiming *pictureTimingSEI = new SEIPictureTiming();
-#endif
 
   const TComVUI *vui = slice->getSPS()->getVuiParameters();
Index: /branches/HTM-15.2-dev/source/Lib/TLibEncoder/TEncSearch.cpp
===================================================================
--- /branches/HTM-15.2-dev/source/Lib/TLibEncoder/TEncSearch.cpp	(revision 1366)
+++ /branches/HTM-15.2-dev/source/Lib/TLibEncoder/TEncSearch.cpp	(revision 1367)
@@ -113,4 +113,5 @@
 , m_iSearchRange (0)
 , m_bipredSearchRange (0)
+, m_motionEstimationSearchMethod (MESEARCH_FULL)
 , m_pppcRDSbacCoder (NULL)
 , m_pcRDGoOnSbacCoder (NULL)
@@ -6708,5 +6709,4 @@
               }
 
-
               DEBUG_STRING_NEW(sSingleStringTest)
 #if NH_MV
@@ -6718,5 +6718,4 @@
                 D_PRINT_INC_INDENT(g_traceModeCheck, "NonZero");
 #endif
-
                 if (isFirstMode)
                 {
Index: /branches/HTM-15.2-dev/source/Lib/TLibEncoder/TEncSlice.cpp
===================================================================
--- /branches/HTM-15.2-dev/source/Lib/TLibEncoder/TEncSlice.cpp	(revision 1366)
+++ /branches/HTM-15.2-dev/source/Lib/TLibEncoder/TEncSlice.cpp	(revision 1367)
@@ -318,6 +318,10 @@
   else
   {
+#if NH_MV
 #if 0 // Check this! NH_MV
     rpcSlice->setTemporalLayerNonReferenceFlag(!m_pcCfg->getGOPEntry( (eSliceTypeBaseView == I_SLICE) ? MAX_GOP : iGOPid ).m_refPic);
+#else
+    rpcSlice->setTemporalLayerNonReferenceFlag(!m_pcCfg->getGOPEntry(iGOPid).m_refPic);
+#endif
 #else
     rpcSlice->setTemporalLayerNonReferenceFlag(!m_pcCfg->getGOPEntry(iGOPid).m_refPic);