Index: branches/SHM-dev/source/Lib/TAppCommon/program_options_lite.cpp
===================================================================
--- branches/SHM-dev/source/Lib/TAppCommon/program_options_lite.cpp	(revision 1373)
+++ branches/SHM-dev/source/Lib/TAppCommon/program_options_lite.cpp	(revision 1377)
@@ -294,4 +294,7 @@
       if (!found)
       {
+#if 1 //SVC_EXTENSION
+        if( error_reporter.verbose )
+#endif
         error_reporter.error(where())
           << "Unknown option `" << name << "' (value:`" << value << "')\n";
Index: branches/SHM-dev/source/Lib/TAppCommon/program_options_lite.h
===================================================================
--- branches/SHM-dev/source/Lib/TAppCommon/program_options_lite.h	(revision 1373)
+++ branches/SHM-dev/source/Lib/TAppCommon/program_options_lite.h	(revision 1377)
@@ -66,9 +66,17 @@
     struct ErrorReporter
     {
-      ErrorReporter() : is_errored(0) {}
+      ErrorReporter()
+      : is_errored(0)
+#if 1 //SVC_EXTENSION
+      , verbose(true)
+#endif
+      {}
       virtual ~ErrorReporter() {}
       virtual std::ostream& error(const std::string& where);
       virtual std::ostream& warn(const std::string& where);
       bool is_errored;
+#if 1 //SVC_EXTENSION
+      bool verbose;
+#endif
     };
 
Index: branches/SHM-dev/source/Lib/TLibCommon/TComRom.cpp
===================================================================
--- branches/SHM-dev/source/Lib/TLibCommon/TComRom.cpp	(revision 1373)
+++ branches/SHM-dev/source/Lib/TLibCommon/TComRom.cpp	(revision 1377)
@@ -56,4 +56,34 @@
   switch (type)
   {
+    case NAL_UNIT_CODED_SLICE_TRAIL_R:    return "   TRAIL_R";
+    case NAL_UNIT_CODED_SLICE_TRAIL_N:    return "   TRAIL_N";
+    case NAL_UNIT_CODED_SLICE_TSA_R:      return "     TSA_R";
+    case NAL_UNIT_CODED_SLICE_TSA_N:      return "     TSA_N";
+    case NAL_UNIT_CODED_SLICE_STSA_R:     return "    STSA_R";
+    case NAL_UNIT_CODED_SLICE_STSA_N:     return "    STSA_N";
+    case NAL_UNIT_CODED_SLICE_BLA_W_LP:   return "  BLA_W_LP";
+    case NAL_UNIT_CODED_SLICE_BLA_W_RADL: return "BLA_W_RADL";
+    case NAL_UNIT_CODED_SLICE_BLA_N_LP:   return "  BLA_N_LP";
+    case NAL_UNIT_CODED_SLICE_IDR_W_RADL: return "IDR_W_RADL";
+    case NAL_UNIT_CODED_SLICE_IDR_N_LP:   return "  IDR_N_LP";
+    case NAL_UNIT_CODED_SLICE_CRA:        return "       CRA";
+    case NAL_UNIT_CODED_SLICE_RADL_R:     return "    RADL_R";
+    case NAL_UNIT_CODED_SLICE_RADL_N:     return "    RADL_N";
+    case NAL_UNIT_CODED_SLICE_RASL_R:     return "    RASL_R";
+    case NAL_UNIT_CODED_SLICE_RASL_N:     return "    RASL_N";
+    case NAL_UNIT_VPS:                    return "       VPS";
+    case NAL_UNIT_SPS:                    return "       SPS";
+    case NAL_UNIT_PPS:                    return "       PPS";
+    case NAL_UNIT_ACCESS_UNIT_DELIMITER:  return "       AUD";
+    case NAL_UNIT_EOS:                    return "       EOS";
+    case NAL_UNIT_EOB:                    return "       EOB";
+    case NAL_UNIT_FILLER_DATA:            return "    FILLER";
+    case NAL_UNIT_PREFIX_SEI:             return "       SEI";
+    case NAL_UNIT_SUFFIX_SEI:             return "       SEI";
+    default:                              return "       UNK";
+  }
+#else
+  switch (type)
+  {
   case NAL_UNIT_CODED_SLICE_TRAIL_R:    return "TRAIL_R";
   case NAL_UNIT_CODED_SLICE_TRAIL_N:    return "TRAIL_N";
@@ -82,34 +112,4 @@
   case NAL_UNIT_SUFFIX_SEI:             return "Suffix SEI";
   default:                              return "UNK";
-  }
-#else
-switch (type)
-  {
-    case NAL_UNIT_CODED_SLICE_TRAIL_R:    return "   TRAIL_R";
-    case NAL_UNIT_CODED_SLICE_TRAIL_N:    return "   TRAIL_N";
-    case NAL_UNIT_CODED_SLICE_TSA_R:      return "     TSA_R";
-    case NAL_UNIT_CODED_SLICE_TSA_N:      return "     TSA_N";
-    case NAL_UNIT_CODED_SLICE_STSA_R:     return "    STSA_R";
-    case NAL_UNIT_CODED_SLICE_STSA_N:     return "    STSA_N";
-    case NAL_UNIT_CODED_SLICE_BLA_W_LP:   return "  BLA_W_LP";
-    case NAL_UNIT_CODED_SLICE_BLA_W_RADL: return "BLA_W_RADL";
-    case NAL_UNIT_CODED_SLICE_BLA_N_LP:   return "  BLA_N_LP";
-    case NAL_UNIT_CODED_SLICE_IDR_W_RADL: return "IDR_W_RADL";
-    case NAL_UNIT_CODED_SLICE_IDR_N_LP:   return "  IDR_N_LP";
-    case NAL_UNIT_CODED_SLICE_CRA:        return "       CRA";
-    case NAL_UNIT_CODED_SLICE_RADL_R:     return "    RADL_R";
-    case NAL_UNIT_CODED_SLICE_RADL_N:     return "    RADL_N";
-    case NAL_UNIT_CODED_SLICE_RASL_R:     return "    RASL_R";
-    case NAL_UNIT_CODED_SLICE_RASL_N:     return "    RASL_N";
-    case NAL_UNIT_VPS:                    return "       VPS";
-    case NAL_UNIT_SPS:                    return "       SPS";
-    case NAL_UNIT_PPS:                    return "       PPS";
-    case NAL_UNIT_ACCESS_UNIT_DELIMITER:  return "       AUD";
-    case NAL_UNIT_EOS:                    return "       EOS";
-    case NAL_UNIT_EOB:                    return "       EOB";
-    case NAL_UNIT_FILLER_DATA:            return "    FILLER";
-    case NAL_UNIT_PREFIX_SEI:             return "       SEI";
-    case NAL_UNIT_SUFFIX_SEI:             return "       SEI";
-    default:                              return "       UNK";
   }
 #endif
Index: branches/SHM-dev/source/Lib/TLibDecoder/TDecTop.cpp
===================================================================
--- branches/SHM-dev/source/Lib/TLibDecoder/TDecTop.cpp	(revision 1373)
+++ branches/SHM-dev/source/Lib/TLibDecoder/TDecTop.cpp	(revision 1377)
@@ -40,18 +40,18 @@
 
 #if SVC_EXTENSION
-UInt  TDecTop::m_prevPOC = MAX_UINT;
-UInt  TDecTop::m_uiPrevLayerId = MAX_UINT;
-Bool  TDecTop::m_bFirstSliceInSequence = true;
-Bool  TDecTop::m_checkPocRestrictionsForCurrAu       = false;
-Int   TDecTop::m_pocResetIdcOrCurrAu                 = -1;
-Bool  TDecTop::m_baseLayerIdrFlag                    = false;
-Bool  TDecTop::m_baseLayerPicPresentFlag             = false;
-Bool  TDecTop::m_baseLayerIrapFlag                   = false;
-Bool  TDecTop::m_nonBaseIdrPresentFlag               = false;
-Int   TDecTop::m_nonBaseIdrType                      = -1;
-Bool  TDecTop::m_picNonIdrWithRadlPresentFlag        = false;
-Bool  TDecTop::m_picNonIdrNoLpPresentFlag            = false;
-Int   TDecTop::m_crossLayerPocResetPeriodId          = -1;
-Int   TDecTop::m_crossLayerPocResetIdc               = -1;
+UInt  TDecTop::m_prevPOC                       = MAX_UINT;
+UInt  TDecTop::m_uiPrevLayerId                 = MAX_UINT;
+Bool  TDecTop::m_bFirstSliceInSequence         = true;
+Bool  TDecTop::m_checkPocRestrictionsForCurrAu = false;
+Int   TDecTop::m_pocResetIdcOrCurrAu           = -1;
+Bool  TDecTop::m_baseLayerIdrFlag              = false;
+Bool  TDecTop::m_baseLayerPicPresentFlag       = false;
+Bool  TDecTop::m_baseLayerIrapFlag             = false;
+Bool  TDecTop::m_nonBaseIdrPresentFlag         = false;
+Int   TDecTop::m_nonBaseIdrType                = -1;
+Bool  TDecTop::m_picNonIdrWithRadlPresentFlag  = false;
+Bool  TDecTop::m_picNonIdrNoLpPresentFlag      = false;
+Int   TDecTop::m_crossLayerPocResetPeriodId    = -1;
+Int   TDecTop::m_crossLayerPocResetIdc         = -1;
 #endif
 
@@ -2579,7 +2579,4 @@
       || pps.getCGSFlag() > 0
 #endif
-#if LAYER_CTB
-      || pcTDecTopBase->getActiveSPS()->getMaxCUWidth() != m_ppcTDecTop[m_layerId]->getActiveSPS()->getMaxCUWidth() || pcTDecTopBase->getActiveSPS()->getMaxCUHeight() != m_ppcTDecTop[m_layerId]->getActiveSPS()->getMaxCUHeight() || pcTDecTopBase->getActiveSPS()->getMaxCUDepth() != m_ppcTDecTop[m_layerId]->getActiveSPS()->getMaxCUDepth()
-#endif
       )
     {
Index: branches/SHM-dev/source/Lib/TLibEncoder/TEncTop.cpp
===================================================================
--- branches/SHM-dev/source/Lib/TLibEncoder/TEncTop.cpp	(revision 1373)
+++ branches/SHM-dev/source/Lib/TLibEncoder/TEncTop.cpp	(revision 1377)
@@ -743,7 +743,4 @@
             || m_cPPS.getCGSFlag() > 0
 #endif
-#if LAYER_CTB
-            || pcEncTopBase->getSPS()->getMaxCUWidth() != m_cSPS.getMaxCUWidth() || pcEncTopBase->getSPS()->getMaxCUHeight() != m_cSPS.getMaxCUHeight() || pcEncTopBase->getSPS()->getMaxCUDepth() != m_cSPS.getMaxCUDepth()
-#endif
             )
           {
@@ -792,7 +789,4 @@
 #if CGS_3D_ASYMLUT
             || m_cPPS.getCGSFlag() > 0
-#endif
-#if LAYER_CTB
-            || pcEncTopBase->getSPS()->getMaxCUWidth() != m_cSPS.getMaxCUWidth() || pcEncTopBase->getSPS()->getMaxCUHeight() != m_cSPS.getMaxCUHeight() || pcEncTopBase->getSPS()->getMaxCUDepth() != m_cSPS.getMaxCUDepth()
 #endif
             )